//---------------------------------------------------------------------------
//      DS28E05
//---------------------------------------------------------------------------
#pragma hdrstop
#include "DS28E05.h"
#include "ProgressBar.h"        //   -
#include "MainProgram.h"        //    
#include "ChipFunctions.h"      //      
#include "PortFunctions.h"      //    
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---    (0x55) (  1, 2) -----------------------------
//---------------------------------------------------------------------------
// input:       Input.PB, Input.AreaNumber
// output:      Test - ,      (0xFF) + Success
DS28E05_OUTPUT_DATA DS28E05_WriteToMemory(DS28E05_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS28E05_OUTPUT_DATA OutputData;       //   
  unsigned int Address;                 //   
  unsigned char Sended1, Sended2, Readed1, Readed2;     //    
  AnsiString TempStr;                   //   
  char TempBuf[1], OutHexBuf[3];        //  
  unsigned char PageNum, SegNum;        //     ,    

  OutputData.Test=0;
  OutputData.Success=false;             //   

  PageNum=(InputData.PB>>4)&7;          //  page number
  Address = PageNum*16;                 //   
  if(PageNum<7)         SegNum = 8;     //    0  6  8 
  else                  SegNum = 3;     //  7   3  

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();          //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //  Write Data
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Write Data
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //   
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=InputData.PB;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  // 0xFF
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xFF;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //***     (SegNum   2 ) ***
  for(unsigned char i=0; i<SegNum; i++)          //   ,   
  { //   
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:   wr_buf.Data[1]=SelectedChip.Area1[Address-SelectedChip.Area1Start];     //    
                break;
      case 2:   wr_buf.Data[1]=SelectedChip.Area2[Address-SelectedChip.Area2Start];     //    
                break;
      default:  return OutputData;
    }
    Sended1=wr_buf.Data[1];
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Address+=1;                                         //  
    //   
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    switch(InputData.AreaNumber)
    { case 1:   wr_buf.Data[1]=SelectedChip.Area1[Address-SelectedChip.Area1Start];     //    
                break;
      case 2:   wr_buf.Data[1]=SelectedChip.Area2[Address-SelectedChip.Area2Start];     //    
                break;
      default:  return OutputData;
    }
    Sended2=wr_buf.Data[1];
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Address+=1;                                         //  
    //    
    //  
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                  //   
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();            //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   ( )
    rd_buf=ReadFrom();                                // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                      //    -
                       ClosePort();
                       return OutputData;
                     }
    Readed1=rd_buf.Data[0];                       // 
    Sleep(1);
    //  
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                  //   
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();            //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   ( )
    rd_buf=ReadFrom();                                // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                      //    -
                       ClosePort();
                       return OutputData;
                     }
    Readed2=rd_buf.Data[0];                       // 
    Sleep(1);
    // ,      
    if(Sended1!=Readed1 || Sended2!=Readed2) { SendMsgToLogForm(29,"");         //  
                                               LBar->Free();                    //    -
                                               return OutputData;
                                             }
    //  0xFF (release byte)
    wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                  // SendByte_1W
    wr_buf.Data[1]=0xFF;
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();            //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(16);  // program time
    //   CS
    //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                  //   
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();            //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //     (CS)
    rd_buf=ReadFrom();                                // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                      //    -
                       ClosePort();
                       return OutputData;
                     }
    if(rd_buf.Data[0]==0x33)    { TempBuf[0]=Address-1;
                                  BinToHex(TempBuf,OutHexBuf,1);      //     ()
                                  OutHexBuf[2]=0;                     //    
                                  TempStr = OutHexBuf;
                                  TempStr += ":";
                                  TempBuf[0]=Address;
                                  BinToHex(TempBuf,OutHexBuf,1);      //     ()
                                  OutHexBuf[2]=0;                     //    
                                  TempStr += OutHexBuf;
                                  SendMsgToLogForm(30,TempStr);       //  cs=0x33 - write protected
                                }
    Sleep(1);

    LBar->ProgressBar1->Position=100*(i+1)/SegNum;           //    -
    Sleep(1);
  }
  // ,     (  ,    1-)
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;          //    Test   
}
//---------------------------------------------------------------------------
//---    (0xF0) (  Area1, Area2) ----------------------
//---------------------------------------------------------------------------
// input:       Input.TA1, Input.TA2, Input.Size, Input.AreaNumber
// output:      Test - ,       (0xFF) + Success
DS28E05_OUTPUT_DATA DS28E05_ReadFromMemory(DS28E05_INPUT_DATA InputData)
{ WRITE_BUFFER wr_buf;                  //    
  READ_BUFFER rd_buf;                   //    
  DS28E05_OUTPUT_DATA OutputData;       //   
  unsigned int Address;           	//   

  OutputData.Test=0;
  OutputData.Success=false;             //  
  Address=InputData.TA1+0xFF*InputData.TA2;             //    ,    

  //  -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                         //     

  //  Reset
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  Match ROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0x55;                                  // Match ROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  8  ROM-
  for(unsigned int i=0; i<8; i++)                       //   
  { wr_buf.Size=2;
    wr_buf.Data[0]=0x61;                                // SendByte_1W
    wr_buf.Data[1]=SelectedChip.ROM[i];                 // ROM Bytes
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
  }
  //   EEPROM
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=0xF0;                                  // Read EEPROM
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(10);
  //  TA1
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=InputData.TA1;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //  TA2
  wr_buf.Size=2;
  wr_buf.Data[0]=0x61;                                  // SendByte_1W
  wr_buf.Data[1]=InputData.TA2;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //***    ***
  for(unsigned int i=0; i<InputData.Size; i++)          //     
  { //   
    wr_buf.Size=1;
    wr_buf.Data[0]=0x62;                                // ReadByte_1W
    if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                           LBar->Free();                //    -
                           ClosePort();
                           return OutputData;
                         }
    Sleep(1);
    //   
    rd_buf=ReadFrom();                                  // 
    if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                       LBar->Free();                    //    -
                       ClosePort();
                       return OutputData;
                     }
    switch(InputData.AreaNumber)
    { case 1:   SelectedChip.Area1[Address-SelectedChip.Area1Start]=rd_buf.Data[0];     //     Area1
                break;
      case 2:   SelectedChip.Area2[Address-SelectedChip.Area2Start]=rd_buf.Data[0];     //     Area2
                break;
      default:  break;
    }
    Sleep(1);
    Address+=1;                                                         //  

    LBar->ProgressBar1->Position=100*(i+1)/InputData.Size;      //    -
    Sleep(1);
  }
  //         (Test)
  Sleep(1);
  wr_buf.Size=1;
  wr_buf.Data[0]=0x62;                                  //   
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();                  //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  //     (Test)
  rd_buf=ReadFrom();                                    // 
  if(!rd_buf.Size) { SendMsgToLogForm(21,"");          //   
                     LBar->Free();                      //    -
                     ClosePort();
                     return OutputData;
                   }
  OutputData.Test=rd_buf.Data[0];
  Sleep(1);
  //  Reset   
  wr_buf.Size=1;
  wr_buf.Data[0]=0x60;
  if(!WriteTo(wr_buf)) { SendMsgToLogForm(11,"");          //   
                         LBar->Free();            //    -
                         ClosePort();
                         return OutputData;
                       }
  Sleep(1);
  LBar->Free();                                         //    -
  OutputData.Success=true;
  return OutputData;
}
//---------------------------------------------------------------------------  